HDU 1856 More is better(并查集)

链接:http://acm.hdu.edu.cn/showproblem.php?pid=1856

Description

Mr Wang wants some boys to help him with a project. Because the project is rather complex, the more boys come, the better it will be. Of course there are certain requirements.

Mr Wang selected a room big enough to hold the boys. The boy who are not been chosen has to leave the room immediately. There are 10000000 boys in the room numbered from 1 to 10000000 at the very beginning. After Mr Wang’s selection any two of them who are still in this room should be friends (direct or indirect), or there is only one boy left. Given all the direct friend-pairs, you should decide the best way.

Input

The first line of the input contains an integer n (0 ≤ n ≤ 100 000) - the number of direct friend-pairs. The following n lines each contains a pair of numbers A and B separated by a single space that suggests A and B are direct friends. (A ≠ B, 1 ≤ A, B ≤ 10000000)

Output

The output in one line contains exactly one integer equals to the maximum number of boys Mr Wang may keep.

Sample Input

4
1 2
3 4
5 6
1 6
4
1 2
3 4
5 6
7 8

Sample Output

4
2

Hint

A and B are friends(direct or indirect), B and C are friends(direct or indirect), then A and C are also friends(indirect). In the first sample {1,2,5,6} is the result. In the second sample {1,2},{3,4},{5,6},{7,8} are four kinds of answers.

题意:找出朋友圈最大的那个集合的成员个数。因为留下来的都必须互相认识,所以只有把集合最大的那个留下才最优

解题技巧:建立并查集,然后用一个数组ant[maxn]记录每个集合的元素个数,合并时也把ant[i]合并,这样,只要找出最大的ant[i]即要获得的结果。

代码:

#include
#include
#include
#include
using namespace std;
const int maxn=100010;
int f[maxn],ant[maxn],n,ans;
void init()
{
    for(int i=0;i1;
    }
}
int find(int x)
{
    if(x==f[x])
        return x;
    else
        return f[x]=find(f[x]);
}
void uniont(int a,int b)
{
    int fa=find(a);
    int fb=find(b);
    if(fa==fb) return;
    else{
        if(ant[fa]>=ant[fb])
        {
            f[fb]=f[fa];
            ant[fa]+=ant[fb];
            ans=max(ans,ant[fa]);
        }
        else
        {
            f[fa]=f[fb];
            ant[fb]+=ant[fa];
            ans=max(ans,ant[fb]);
        }
    }
}
int main()
{
    int a,b;
    while(~scanf("%d",&n))
    {
        init();
        ans=1;
        for(int i=0;iscanf("%d %d",&a,&b);
            uniont(a,b);
        }
        printf("%d\n",ans);
    }
    return 0;
}

你可能感兴趣的:(并差集)